package org.gidea.scada.monitor.rabbit.config;

import com.rabbitmq.client.Channel;
import lombok.SneakyThrows;
import org.gidea.scada.monitor.utils.Constants;
import org.springframework.amqp.core.FanoutExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.amqp.rabbit.core.RabbitAdmin;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class MonitorRabbitMQConfig {
    @Autowired
    Channel channel;

    @SneakyThrows
    @Bean
    public FanoutExchange exchange(RabbitAdmin rabbitAdmin) {
        FanoutExchange exchange1 = new FanoutExchange(Constants.MonitorServiceExchangeName, true, false);
        FanoutExchange exchange2 = new FanoutExchange(Constants.MonitorClientExchangeName, true, false);
        rabbitAdmin.declareExchange(exchange1);
        rabbitAdmin.declareExchange(exchange2);
//        // 声明请求主队列
        Queue requestQueue = new Queue(Constants.MonitorServiceName, true, true, true);
        rabbitAdmin.declareQueue(requestQueue);

//        channel.queueDeclare(Constants.MonitorServiceName, true, true, true, null);
        channel.queueBind(Constants.MonitorServiceName, Constants.MonitorServiceExchangeName, "");
        return exchange2;
    }

}
